<?php


// HEY CVS, THIS FILE HAS CHANGED!


/**
 * @file
 * markItUp! administration callbacks.
 *
 * @ingroup markitup
 */

/**
 * Defines the administration form.
 */

function markitup_admin_form() {
	$form = array(
		'formats' => array(
			'#theme' => 'markitup_admin_form_table',
			// Using negative weights because the save/reset buttons will have a
			// weight of 0.
			'#weight' => 0,
		),
//		'fields' => array(
//			'#type' => 'textarea',
//			'#title' => t('Active textareas'),
//			'#description' => t('Enter the names of the textareas which should have markItUp! applied to them here, one name per line. (These are the HTML &ldquo;name&rdquo; attributes of the &lt;textarea&gt; tag &mdash; <em>not</em> the titles of the textareas. Use the &ldquo;Show textarea names in titles&rdquo; feature below to identify the names of textareas if you&rsquo;re unsure.)'),
//			'#default_value' => implode("\n", variable_get('markitup_active', array('body','comment'))),
//			'#weight' => 5,
//		),
//		'show_names' => array(
//			'#type' => 'checkbox',
//			'#title' => t('Show textarea names in titles'),
//			'#description' => t('If you are unsure of the name of a textarea you would like to apply markItUp! to, this feature will cause the name of each textarea to appear in its title. Check this box, then navigate to the page which has the desired textarea on it to see its name. Then enter it in the &ldquo;Active textareas&rdquo; field above.'),
//			'#default_value' => variable_get('markitup_show_names', FALSE),
//			'#weight' => 10,
//		),
		
		// We want to add 'Save configuration' / 'Reset to defaults' buttons like
		// system_settings_form() adds, but we can't use that function because
		// it'll automatically save variables in a manner we don't want it to.
		'submit' => array(
			'#type' => 'submit',
			'#value' => t('Save configuration'),
			'#weight' => 15,
		),
		'reset' => array(
			'#type' => 'submit',
			'#value' => t('Reset to defaults'),
			'#weight' => 20,
		),
	);
	
//	$input_formats = _markitup_filter_formats();
	$input_formats = filter_formats();

	$sets = markitup_sets();
	$skins = markitup_skins();
	// Define the sets menu
	$sets_menu = array(
		'#type' => 'select',
		'#options' => array_merge(array(0 => t('(none)')), array_combine($sets, $sets)),
	);
	// Same for the skins
	$skins_menu = array(
		'#type' => 'select',
		'#options' => array_combine($skins, $skins),
	);

	$miu = variable_get('markitup_data', array());
	
	foreach ($input_formats as $if) {
		$form['formats'][$if->format] = array(
			'title_' . $if->format => array(
				'#type' => 'item',
				'#value' => $if->name,
			),
			'set_' . $if->format => array(
				'#default_value' => isset($miu[$if->format]['set']) ? $miu[$if->format]['set'] : 0,
			) + $sets_menu,
			'skin_' . $if->format => array(
				'#default_value' => isset($miu[$if->format]['skin']) ? $miu[$if->format]['skin'] : 'simple',
			) + $skins_menu,
		);
	}
		
//	return system_settings_form($form);
	return $form;
}

/**
 * Theme the admin table.
 */

function theme_markitup_admin_form_table($input_formats) {
	$table = array();
	foreach (element_children($input_formats) as $key) {
		$table[] = array( // tr
			drupal_render($input_formats[$key]['title_' . $key]), // td
			drupal_render($input_formats[$key]['set_' . $key]), // td
			drupal_render($input_formats[$key]['skin_' . $key]), // td
			l(t('Tweaks'), 'admin/settings/markitup/tweak/' . $key), // td
		);
	}
	return theme('table', array(t('Input format'), t('Set'), t('Skin'), t('Tweaks')), $table);
}

/**
 * Submission function for the admin form.
 */

function markitup_admin_form_submit($form, $form_state) {
	if ($form_state['values']['op'] === t('Reset to defaults')) {
		variable_del('markitup_data');
	}
	else {
//		if ($form_state['values']['fields'] !== '') {
//			variable_set('markitup_active', explode("\n", str_replace("\r", '', $form_state['values']['fields'])));
//		}
//		else {
//			variable_set('markitup_active', array());
//		}
		
//		variable_set('markitup_show_names', $form_state['values']['show_names']);
		
//		$input_formats = _markitup_filter_formats();
		$input_formats = filter_formats();
		$data = array();
		foreach ($input_formats as $if) {
			$data[$if->format] = array(
				'set' => $form_state['values']['set_' . $if->format],
				'skin' => $form_state['values']['skin_' . $if->format],
				'tweaks' => array(),
			);
		}
		variable_set('markitup_data', $data);
	}
	// Set a confirmation message like system_settings_form() adds
	drupal_set_message(t('The configuration options have been saved.'));
}

///**
// * Displays the "set tweaking" form.
// */
//
//function markitup_admin_sets_form() {
//	$form = array();
//	$sets = markitup_sets();
//	$i = 0;
//	$tweaks = variable_get('markitup_set_tweaks', array());
//	foreach ($sets as $set) {
//		$form['fieldset_' . $set] = array(
//			'#type' => 'fieldset',
//			'#title' => $set,
//			'#weight' => $i++ * 10,
//			"drupal_break_{$set}" => array(
//				'#type' => 'checkbox',
//				'#title' => t('Add Drupal page break button'),
//				'#default_value' => isset($tweaks[$set]['drupal_break']) ? $tweaks[$set]['drupal_break'] : TRUE,
//				'#weight' => 0,
//			),
//			"preview_{$set}" => array(
//				'#type' => 'radios',
//				'#title' => t('markItUp!&rsquo;s &ldquo;Preview&rdquo; button'),
//				'#options' => array(
//					t('Leave it alone (though it is currently incompatible with Drupal)'),
//					t('Map it to Drupal&rsquo;s standard &ldquo;Preview&rdquo; button'),
//					t('Remove it'),
//				),
//				'#default_value' => isset($tweaks[$set]['preview']) ? $tweaks[$set]['preview'] : 2,
//				'#weight' => 10,
//			),
//		);
//	}
//	// We want to add 'Save configuration' / 'Reset to defaults' buttons like
//	// system_settings_form() adds, but we can't use that function because
//	// it'll automatically save variables in a manner we don't want it to.
//	$form['submit'] = array(
//		'#type' => 'submit',
//		'#value' => t('Save configuration'),
//		'#weight' => $i++ * 10,
//	);
//	$form['reset'] = array(
//		'#type' => 'submit',
//		'#value' => t('Reset to defaults'),
//		'#weight' => $i++ * 10,
//	);
//	
//	return $form;
//}

/**
 * Let the user "tweak" things for the input filter/set combo.
 */

function markitup_tweaks_form($form, $if) {
	$if = intval($if);
	$data = variable_get('markitup_data', array());
	$ifs = filter_formats();
	drupal_set_title(t("markItUp! tweaks for &ldquo;{$ifs[$if]->name}&rdquo; input format"));
	$tweaks = $data[$if]['tweaks'];
	return array(
		'#input_filter' => $if,
		'preview_override' => array(
			'#type' => 'radios',
			'#title' => t('Override markItUp!&rsquo;s standard &ldquo;Preview&rdquo; button'),
			'#options' => array(
				t('Do not override'),
				t('Map it to Drupal&rsquo;s &ldquo;Preview&rdquo; button'),
				t('Remove it'),
			),
			'#description' => t('markItUp!&rsquo;s &ldquo;Preview&rdquo; button is not currently functional with Drupal.'),
			'#default_value' => isset($tweaks['previewOverride']) ? $tweaks['previewOverride'] : 2,
			'#weight' => 0,
		),
		'drupal_break' => array(
			'#type' => 'checkbox',
			'#title' => t('Add Drupal teaser break button'),
			'#default_value' => isset($tweaks['drupalBreak']) ? $tweaks['drupalBreak'] : TRUE,
			'#weight' => 10,
		),
		'submit' => array(
			'#type' => 'submit',
			'#value' => t('Save configuration'),
			'#weight' => 998,
		),
//		'reset' => array(
//			'#type' => 'submit',
//			'#value' => t('Reset to defaults'),
//			'#weight' => 999,
//		),
	);
}

function markitup_tweaks_form_submit($form, $form_state) {
	$data = variable_get('markitup_data', array());
	$if = $form['#input_filter'];
	if (!isset($data[$if])) {
		$data[$if] = array();
	}
	$data[$if]['tweaks'] = array(
		'previewOverride' => intval($form_state['values']['preview_override']),
		'drupalBreak' => $form_state['values']['drupal_break'] === 1,
	);
//	foreach ($form_state['values'] as $key => $val) {
//		if (!in_array($key, array('
//		$sets[$form['#input_filter']]['tweaks'][$key] = $val;
//	}
	variable_set('markitup_data', $data);
	drupal_set_message(t('The configuration options have been saved.'));
	drupal_goto('admin/settings/markitup');
//	var_dump($sets);die();
}

/**
 * Returns all input formats, including a "none" one at the beginning of the
 * array.
 */

//function _markitup_filter_formats() {
//	$default_format = new stdClass();
//	$default_format->format = '0';
//	$default_format->name = t('(none)');
//	return array($default_format) + filter_formats();
//}