
/**
 * @file
 * The markItUp! module JavaScript handler.
 *
 * @ingroup markitup
 */

/*global Drupal, $, jQuery, mySettings */

Drupal.settings.markItUpTweakers = Drupal.settings.markItUpTweakers || {};

Drupal.behaviors.markItUpInit = function() {	
	// Make sure we weren't added on accident
	var markItUpSwitch = function(to) {
		to = Number(to);

		$('textarea.markitup-target').markItUpRemove();
		// Workaround for Webkit - Button bar isn't removing itself for some reason
		$('.markItUpHeader').remove();
		
		if (Drupal.settings.markItUp.currentScript) {
			Drupal.settings.markItUp.currentScript.remove();
			Drupal.settings.markItUp.currentCss.remove();
		}
		
		if (typeof(Drupal.settings.markItUp.data[to].set) === 'undefined' || Drupal.settings.markItUp.data[to].set === '0') {
			if (Drupal.settings.markItUp.currentSkinName) {
				Drupal.settings.markItUp.currentSkin.remove();
				Drupal.settings.markItUp.currentSkinName = false;
				// Reapply grippies
				if (!jQuery.browser.safari) {
					$('textarea.markitup-target').removeClass('textarea-processed');
					Drupal.behaviors.textarea();
				}
			}
		}
		else {
			if (!jQuery.browser.safari) {
				$('.grippie').remove();
			}
			// Add set skin and css
			Drupal.settings.markItUp.currentScript = $('<script>').attr({
				'type': 'text/javascript',
				'defer': 'defer',
				'src': Drupal.settings.markItUp.path + 'sets/' + Drupal.settings.markItUp.data[to].set + '/set.js'
			});

			Drupal.settings.markItUp.currentCss = $('<link>').attr({
				'type': 'text/css',
				'rel': 'stylesheet',
				'media': 'all',
				'href': Drupal.settings.markItUp.path + 'sets/' + Drupal.settings.markItUp.data[to].set + '/style.css'
			});
			$('head').append(Drupal.settings.markItUp.currentScript).append(Drupal.settings.markItUp.currentCss);
			// Is the skin different?
			if (Drupal.settings.markItUp.currentSkinName !== Drupal.settings.markItUp.data[to].skin) {
				if (Drupal.settings.markItUp.currentSkinName) {
					Drupal.settings.markItUp.currentSkin.remove();
				}
				Drupal.settings.markItUp.currentSkinName = Drupal.settings.markItUp.data[to].skin;
				Drupal.settings.markItUp.currentSkin = $('<link>').attr({
					'type': 'text/css',
					'rel': 'stylesheet',
					'media': 'all',
					'href': Drupal.settings.markItUp.path + 'skins/' + Drupal.settings.markItUp.data[to].skin + '/style.css'
				});
				$('head').append(Drupal.settings.markItUp.currentSkin);
			}
		// Execute tweak functions
		jQuery.each(Drupal.settings.markItUpTweakers, function() {
			this(to);
		});
		$('textarea.markitup-target').markItUp(mySettings);
		}
	};
	
	Drupal.settings.markItUp.currentScript = false;
	Drupal.settings.markItUp.currentCss = false;
	Drupal.settings.markItUp.currentSkinName = false;
	Drupal.settings.markItUp.grippieHidden = false;
	
	if ($('textarea.markitup-target').length) {
		if ($('input[name=markitup-pass]').length) {
			markItUpSwitch($('input[name=markitup-pass]').val());
		}
		else if ($('input[name=format]').length) {
			$('input[name=format]').change(function() {
				markItUpSwitch($('input[name=format]:checked').val());
			});
			$('input[name=format]:checked').change();
		}
		// Add textarea-processed to stop Drupal from adding a grippie
		if (!jQuery.browser.safari) {
			$('textarea.markitup-target').addClass('textarea-processed');
		}
	}
};